
;Simple MDI Window - DednDave - 5, 2012

;##############################################################################################

    INCLUDE SimpleMDI.inc

;##############################################################################################

;Initial Window Sizes

MainWidth    = 600
MainHeight   = 400
ChldWidth    = 300
ChldHeight   = 150

;Child Window Background Color

ChildBgColor = COLOR_WINDOW

;##############################################################################################

; ======= Initialized Data Section =======

    .DATA
    ALIGN   4

nChildCount   dd 1                                          ;current child window count

;-----------------------------------------

;Init Common Controls Structure

icc INITCOMMONCONTROLSEX <sizeof INITCOMMONCONTROLSEX,0>

;-----------------------------------------

;Window Class Registration Structure

wc WNDCLASSEX <SIZEOF WNDCLASSEX,NULL,WndProc,0,0,?,?,?,NULL,IDM_MAINMENU,szFrameClass,?>

;-----------------------------------------

;Client Create Structure

ccs CLIENTCREATESTRUCT <?,IDW_FIRSTCHILD>

;-----------------------------------------

;MDI Child Create Structure

StyleFlags = MDIS_ALLCHILDSTYLES
;or WS_HSCROLL or WS_VSCROLL (to add scroll bars to child windows)
mcs MDICREATESTRUCT <szChildClass,szChildTitle,?,CW_USEDEFAULT,CW_USEDEFAULT,ChldWidth,ChldHeight,StyleFlags,0>

;-----------------------------------------

;Caption and Class Strings

szFrameTitle  db 'Simple MDI',0
szChildTitle  db 'Untitled',0
szFrameClass  db 'SimpleFrameClass',0
szClientClass db 'MDICLIENT',0
szChildClass  db 'SimpleChildClass',0

; ====== Uninitialized Data Section ======

    .DATA?
    ALIGN   4

hWin          HWND   ?                                      ;frame window handle
hClient       HWND   ?                                      ;client window handle
hMenu         HMENU  ?                                      ;frame window menu handle
hAccel        HACCEL ?                                      ;menu accelerators handle

;##############################################################################################

; ============ Code Section ==============

    .CODE

;**********************************************************************************************

WndProc PROC USES EBX ESI EDI hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

; =========== Frame Window Proc ===========

    mov     eax,uMsg                                        ;EAX = uMsg
    mov     ebx,hWnd                                        ;EBX = hWnd
    xor     edi,edi                                         ;EDI = 0

; =========== WM_COMMAND ===========

    .if eax==WM_COMMAND
        movzx   edx,word ptr wParam+2                       ;source identifier/notification code
        .if edx<=1                                          ;menu=0, accel=1, control=notification code
            movzx   eax,word ptr wParam                     ;menu/accel/control ID
            mov     esi,hClient                             ;ESI = hClient

            .if eax==IDM_FILEEXIT
                INVOKE  PostMessage,ebx,WM_SYSCOMMAND,SC_CLOSE,edi

            .elseif eax==IDM_FILENEW
                INVOKE  SendMessage,esi,WM_MDICREATE,edi,offset mcs

                ;a handle to the child window is returned if successful

                .if eax
                    inc     nChildCount                     ;adjust child window count
                .endif

            .elseif eax==IDM_FILEARRANGE_TILEHORZ
                INVOKE  SendMessage,esi,WM_MDITILE,MDITILE_HORIZONTAL or MDITILE_SKIPDISABLED,edi

            .elseif eax==IDM_FILEARRANGE_TILEVERT
                INVOKE  SendMessage,esi,WM_MDITILE,MDITILE_VERTICAL or MDITILE_SKIPDISABLED,edi

            .elseif eax==IDM_FILEARRANGE_CASCADE
                INVOKE  SendMessage,esi,WM_MDICASCADE,MDITILE_SKIPDISABLED or MDITILE_ZORDER,edi

            .elseif eax==IDM_FILEARRANGE_ICONS
                INVOKE  SendMessage,esi,WM_MDIICONARRANGE,edi,edi

            .else
                jmp     WProc0                              ;allow default processing

            .endif
            xchg    eax,edi                                 ;return 0

        .endif
        jmp     WProc0                                      ;allow default processing

; ============ WM_CLOSE ============

    .elseif eax==WM_CLOSE
        INVOKE  DestroyWindow,hWnd
        xchg    eax,edi                                     ;return 0

; =========== WM_DESTROY ===========

    .elseif eax==WM_DESTROY
        INVOKE  PostQuitMessage,edi
        xchg    eax,edi                                     ;return 0

; =========== WM_CREATE ============

    .elseif eax==WM_CREATE
        mov     esi,wc.hInstance                            ;ESI = hInstance
        mov     hWin,ebx                                    ;initialize hWin

        ; ----------- Initialize client create structure -----------

        ;we need a handle to the menu where the client will update the child list

        INVOKE  GetMenu,ebx
        mov     hMenu,eax
        INVOKE  GetSubMenu,eax,edi
        mov     edx,offset ccs
        mov     [edx].CLIENTCREATESTRUCT.hWindowMenu,eax

        ; ----------- Create client window -----------

        INVOKE  CreateWindowEx,edi,offset szClientClass,edi,
                WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN,
                edi,edi,edi,edi,ebx,edi,esi,edx
        mov     hClient,eax

        ; ----------- Load keyboard accelerators -----------

        INVOKE  LoadAccelerators,esi,IDA_ACC
        mov     hAccel,eax
        xchg    eax,edi                                     ;return 0

    .else

WProc0: INVOKE  DefFrameProc,hWnd,hClient,uMsg,wParam,lParam

    .endif

    ret

WndProc ENDP

;**********************************************************************************************

ChildProc PROC USES EBX ESI EDI hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

; =========== Child Window Proc ===========

    mov     eax,uMsg

; ============ WM_CLOSE ============

    .if eax==WM_CLOSE
        dec     nChildCount                                 ;adjust child window count
        jmp     CProc0                                      ;default processing handles close

    .else

CProc0: INVOKE  DefMDIChildProc,hWnd,uMsg,wParam,lParam

    .endif

    ret

ChildProc ENDP

;**********************************************************************************************

WinMain PROC

; =========== Main Proc ===========

; ----------- Initialize common controls -----------

    INVOKE  InitCommonControlsEx,offset icc

; ----------- Register frame window class -----------

    xor     edi,edi                                         ;EDI = 0
    mov     esi,offset wc                                   ;ESI = offset wc
    INVOKE  GetModuleHandle,edi
    mov     [esi].WNDCLASSEX.hInstance,eax
    mov     mcs.hOwner,eax
    xchg    eax,ebx                                         ;EBX = wc.hInstance
    INVOKE  LoadCursor,edi,IDC_ARROW
    mov     [esi].WNDCLASSEX.hCursor,eax
    INVOKE  LoadIcon,ebx,IDI_ICON
    mov     [esi].WNDCLASSEX.hIcon,eax
    mov     [esi].WNDCLASSEX.hIconSm,eax
    INVOKE  RegisterClassEx,esi

; ----------- Register child window class -----------

    mov     [esi].WNDCLASSEX.lpfnWndProc,ChildProc
    push    32
    pop     [esi].WNDCLASSEX.cbWndExtra
    mov     [esi].WNDCLASSEX.hbrBackground,ChildBgColor+1
    mov     [esi].WNDCLASSEX.lpszClassName,offset szChildClass
    INVOKE  RegisterClassEx,esi

; ----------- Create frame window -----------

StyleFlags = WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN
;or WS_HSCROLL or WS_VSCROLL (to add scroll bars to frame window)

    INVOKE  CreateWindowEx,edi,offset szFrameClass,offset szFrameTitle,StyleFlags,
            CW_USEDEFAULT,SW_SHOWNORMAL,MainWidth,MainHeight,edi,edi,ebx,edi

    xchg    eax,ebx                                         ;EBX = hWin
    mov     esi,hClient                                     ;ESI = hClient
    INVOKE  UpdateWindow,ebx

; ----------- Create the first child "automatically" -----------

;the child window count is already initialized to 1

    INVOKE  SendMessage,esi,WM_MDICREATE,edi,offset mcs

; ----------- Message loop -----------

;a special message loop is required to handle keyboard accelerators

    sub     esp,sizeof MSG
    mov     ebp,esp                                         ;EBP = address of MSG structure

    .while TRUE
        INVOKE  GetMessage,ebp,edi,edi,edi
        inc     eax                                         ;exit only
        shr     eax,1                                       ;if EAX = 0 or -1
    .break .if !eax
        INVOKE  TranslateMDISysAccel,esi,ebp
        .if !eax
            INVOKE  TranslateAccelerator,ebx,hAccel,ebp
            .if !eax
                INVOKE  TranslateMessage,ebp
                INVOKE  DispatchMessage,ebp
            .endif
        .endif
    .endw

    INVOKE  ExitProcess,[ebp].MSG.wParam

WinMain ENDP

;##############################################################################################

        END     WinMain

